<template>
    <div class="col-md-4 offset-4">
      <p v-if="errors.length">
        <b>Por favor, corrija el(los) siguiente(s) error(es):</b>
        <ul>
          <li  v-for="(error, index) in errors" :key="index">{{ error }}</li>
        </ul>
      </p>
      <div class="card card-body">
        <h1 class="card-title my-3 text-center">Crear Empleado</h1>
        <form @submit.prevent="checkForm">
          <span>Primer Nombre: </span>
        <input
            class="form-control mb-3"
            placeholder="Primer Nombre"
            type="title"
            v-model="user.fistName"
            autofocus
          />
          <span>Otros Nombres: </span>
          <input
            class="form-control mb-3"
            placeholder="Otros Nombres"
            rows="3"
            v-model="user.otherName"
          />
          <span>Primer Apellido: </span>
          <input
            class="form-control mb-3"
            placeholder="Primer Apellido"
            type="title"
            v-model="user.firstSurname"
            autofocus
          />
          <span>Segndo Apellido: </span>
          <input
            class="form-control mb-3"
            placeholder="Segndo Apellido"
            rows="3"
            v-model="user.secondSurname"
          />
          <span>Tipo de documento: </span>
          <select v-model="user.idType" class="form-select mb-3" aria-label="Default select example">
            <option selected value="Cédula de Ciudadanía">Cédula de Ciudadanía</option>
            <option value="Cédula de Ciudadanía">Cédula de Extranjería</option>
            <option value="Pasaporte">Pasaporte</option>
            <option value="Permiso Especial">Permiso Especial</option>
          </select>
          <span>Numero de identificacion: </span>
          <input
            class="form-control mb-3"
            placeholder="Número de Identificación"
            rows="3"
            v-model="user.idNumber"
          />
          <span>País: </span>
          <select v-model="user.country" class="form-select mb-3">
            <option selected value="Colombia ">Colombia </option>
            <option value="Estados Unidos">Estados Unidos</option>
          </select>
          <span>Fecha de ingreso: </span>
          <input
            class="form-control mb-3"
            placeholder="Fecha de ingreso"
            type="date"
            v-model="user.dateIn"
            autofocus
          />
          <span>Área: </span>
          <select v-model="user.area" class="form-select mb-3">
            <option selected value="Administración ">Administración </option>
            <option value="Financiera">Financiera</option>
            <option selected value="Compras">Compras</option>
            <option value="Infraestructura">Infraestructura</option>
            <option selected value="Operación ">Operación </option>
            <option value="Talento Humano">Talento Humano</option>
            <option value="Servicios Varios">Servicios Varios</option>
          </select>
          <button
            class="btn btn-primary w-100"
            :disabled="!user.fistName || !user.otherName 
            || !user.area || !user.country || !user.dateIn 
            || !user.firstSurname || !user.idNumber || !user.idType 
            || !user.secondSurname"
          >
            save
          </button>
        </form>
      </div>
    </div>
  </template>
  
  <script lang="ts">
  import { defineComponent } from "vue";
  import { User } from "@/interfaces/user";
  import { createTask } from "@/services/userServices";
  export default defineComponent({
    data() {
      return {
        user: {} as User,
        errors: [] as string[]
      };
    },
    methods: {
      async saveTask() {
        try {
          const res = await createTask(this.user);
          console.log(res);
          this.$router.push({ name: "users" });
        } catch (error) {
          console.error(error);
        }
      },
      // Validacion de inpts con expresiones regulares

      checkForm: function (e: any) {
        this.errors = [];

        if (!this.user.fistName) {
          this.errors.push("El nombre es obligatorio.");
        }else if (!this.validCaracteres(this.user.fistName)) {
          this.errors.push('El Nombre debe ser valido.');
        }

        if (!this.user.firstSurname) {
          this.errors.push("El Primer apellido es obligatorio.");
        }else if (!this.validCaracteres(this.user.firstSurname)) {
          this.errors.push('El Primer apellido debe ser valido.');
        }

        if (!this.user.secondSurname) {
          this.errors.push("El Segundo Apellido es obligatorio.");
        }else if (!this.validCaracteres(this.user.secondSurname)) {
          this.errors.push('El Segundo Apellido debe ser valido.');
        }

        if (!this.validOtherName(this.user.otherName)) {
          this.errors.push('El campo Otros Nombres debe ser valido.');
        }

        if (!this.user.idNumber) {
          this.errors.push('El numero de identidad es obligatorio.');
        } else if (!this.validIdNumber(this.user.idNumber)) {
          this.errors.push('El numero de identidad debe ser válido.');
        }

        if (!this.errors.length) {
          this.saveTask()
          return true;
        }else{
          //
        }

        e.preventDefault();
      },
      validEmail(email: string){
        var re = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
        return re.test(email);
      },

      validCaracteres(input: string){
        var re = /^([a-zA-ZáéíóúÁÉÍÓÚ]{1,20})$/;
        return re.test(input);
      },

      validOtherName(input: string){
        var re = /^([a-zA-ZáéíóúÁÉÍÓÚ]{1,50})$/;
        return re.test(input);
      },

      validIdNumber(input: string){
        var re = /^([0-9]{1,20})$/;
        return re.test(input);
      }
  }
  });
  </script>